// Program: Lesson 21, Exercise 3

#include <iostream.h>
#include <string.h>

class Person {
 public:
   char    name[12];
   Person* frnd[5];

   int     frnd_nb;

   void    initialize();
   void    set_name(char[]);
   void    set_frnd(Person*);
   void    print_status(void);
 };

void Person::initialize(void)
 {
    for (int i = 0; i < 5; ++i)
      frnd[i] = NULL;

    frnd_nb = 0;
 }

void Person::set_name (char a_name[])
 {
    strcpy (name, a_name);
 }

void Person::set_frnd(Person* p)
 {
    frnd[frnd_nb] = p;
    frnd_nb = (frnd_nb+1)%5;
 }

void Person::print_status(void)
 {
    cout << name << "\'s friends are: " << endl;
    for (int i = 0; frnd[i]; ++i)
       cout << "(" << i+1 << ")" << " " << frnd[i]->name << endl;
    cout << endl;
 }


void main(void)
 {
    Person Avi, Shulamit, Hila;

    Avi.initialize();
    Shulamit.initialize();
    Hila.initialize();

    Avi.set_name("Avi");
    Shulamit.set_name("Shulamit");
    Hila.set_name("Hila");

    Avi.set_frnd(&Hila);
    Hila.set_frnd(&Avi);
    Hila.set_frnd(&Shulamit);
    Shulamit.set_frnd(&Hila);

    Avi.print_status();
    Hila.print_status();
    Shulamit.print_status();
 }
