// Program: Lesson 26 - Excercise 4

#include <iostream.h>
#include <string.h>

class thing
{
 public:
	thing(char* s)   { strcpy (str, s); }
	void print(void) { cout << str << endl; }

 private:
	char str[80];
 };


class thing_list : public thing
{
 public:
	thing_list(char* s, thing_list* next = NULL);
	~thing_list();
	void	add(char* s);
	void 	print_list(void);
 private:
	thing_list* next;
};

thing_list::thing_list(char* s, thing_list* next) : thing(s)
 {
	thing_list::next = next;
 }

thing_list::~thing_list()
 {
	if (next != NULL)
		delete next;
 }


void thing_list::add(char* s)
 {
	next = new thing_list(s, next);
 }

void thing_list::print_list(void)
 {
	print();
	if (next != NULL)
		next -> print_list();
 }


void main(void)
 {
	thing_list list("item1");
	list.add("item2");
	list.add("item3");
	list.print_list();
 }