// Program: Lesson 27, Exercise 1

#include <iostream.h>

class vehicle {
 public:
   vehicle(float = 0, float = 0, float = 0);
 private:
   float volume;
   float weight;
   float speed;
 };

vehicle :: vehicle(float volume, float weight, float speed)
 {
   vehicle::volume = volume;
   vehicle::weight = weight;
   vehicle::speed  = speed;
 }

class for_sale_item {
 public:
   for_sale_item(long = 0, long = 123456);
 private:
   long price;
   long catalog_nb;
 };

for_sale_item :: for_sale_item(long price, long catalog_nb)
 {
   for_sale_item::price = price;
   for_sale_item::catalog_nb = catalog_nb;
 }

class car : public vehicle, public for_sale_item {
 public:
   car(int, int, long, long, float, float, float);
 private:
   int color;
   int nb_wheels;
 };

car :: car(int color, int nb_wheels, long price, long catalog_nb,
	   float volume, float weight, float speed) :
			  vehicle(volume, weight, speed),
			  for_sale_item(price, catalog_nb)
 {
   car::color = color;
   car::nb_wheels = nb_wheels;
 }

class bicycle : public vehicle, public for_sale_item {
 public:
   bicycle(int, int, long, long, float, float, float);
 private:
   int color;
   int nb_wheels;
 };

bicycle :: bicycle(int color, int nb_wheels, long price, long catalog_nb,
	   float volume, float weight, float speed) :
			  vehicle(volume, weight, speed),
			  for_sale_item(price, catalog_nb)
 {
   bicycle::color = color;
   bicycle::nb_wheels = nb_wheels;
 }

void main(void)
 {
   vehicle* porsche = new car(0, 4, 1000000, 911, 500, 500, 50000);
   for_sale_item* lamburgini = new car(2, 4, 2000000, 707, 200, 300, 75000);

   vehicle* bmx = new bicycle(1, 2, 1000, 141, 10, 15, 40);
   for_sale_item* raleigh = new bicycle(7, 2, 2000, 345, 20, 13, 75);
 }
