// Program: Lesson 38 - Excercise 3

#include <iostream.h>
#include <string.h>

class animal {
  public:
	animal (char* name) { strcpy(animal::name, name); }
	virtual void print(void) =0;
  protected:
	char name[80];
  };


class frog : public animal {
  public:
	frog(char* name) : animal(name) {}
	void print(void) { cout << "I am a frog and my name is " << name <<
		endl; }
  };

class cat : public animal {
  public:
	cat(char* name) : animal(name) {}
	void print(void) { cout << "I am a cat, my name is " << name <<
			" and I'm no frog!" << endl; }
  };


const int NUM_OF_ANIMALS=100;

void main(void)
 {
	animal* zoo[NUM_OF_ANIMALS];
	int occupied = 0; // number of animals in zoo

	while(1) {
		char name[80], c;

		cout << "Enter command:" << endl;
		cout << "f [name] - add a frog to the zoo" << endl;
		cout << "c [name] - add a cat to the zoo" << endl;
		cout << "p        - print zoo" << endl;
		cout << "q        - quit" << endl;

		cin >> c;

		switch(c) {
		case 'p':
			for (int i = 0; i < occupied; i++) {
				cout << "cell " << i << ": " ;
				zoo[i] -> print();
				}
			break;
		case 'q':
			return;
		case 'f':
			cin.get(c); // eating space character
			cin.getline(name,80);
			zoo[occupied++] = new frog(name);
			break;
		case 'c':
			cin.get(c); // eating space character
			cin.getline(name,80);
			zoo[occupied++] = new cat(name);
			break;
		}
	}
 }
