#include <iostream.h>
#include <string.h>

class book_series {
 public:
   static int page_count;
   book_series(char *, char *, float);
   void show_book(void);
 private:
   char title[64];
   char author[64];
   float price;
};

int book_series::page_count;

book_series::book_series(char *title, char *author, float price)
 {
   strcpy(book_series::title, title);
   strcpy(book_series::author, author);
   book_series::price = price;
 }

void book_series::show_book(void)
 {
   cout << "Title: " << title << endl;
   cout << "Author: " << author << endl;
   cout << "Price: " << price << endl;
   cout << "Pages: " << page_count << endl;
 }

void main(void)
 {
   book_series programming("Rescued by C++", "Jamsa", 19.95);
   book_series word("Rescued by Word for Windows", 
     "Wyatt", 19.95);

   word.page_count = 256;

   programming.show_book();
   word.show_book();

   cout << endl << "Changing page count " << endl;

   programming.page_count = 512;

   programming.show_book();
   word.show_book();
 }



 
